<?php

namespace ACL\Services;

use ACL\Helpers\Instances\InstanceProvider;
use ACL\Repositories\Paramgeral as ParamgeralRepository;
use ACL\Traits\TCrud;
use Doctrine\DBAL\Driver\Exception;
use ACL\Util\AclUtilities;

class Paramgeral
{

    use TCrud;

    /**
     * @var \Teknisa\Libs\Util\Environment
     */
    private $libEnvironment;

    /**
     * @var ParamgeralRepository
     */
    private $paramgeralRepository;

    public function __construct(ParamgeralRepository $paramgeralRepository)
    {
        $this->paramgeralRepository = $paramgeralRepository;
        $this->libEnvironment = InstanceProvider::getLibEnvironment();
    }

    /**
     * @return array
     */
   public function findParamgeral(): array
   {
       return $this->paramgeralRepository->findParamgeral(getNrorg());
   }

    /**
     * @param $idutctrlacesweb
     * @return string[]
     * @throws Exception
     * @throws \Exception
     */
   public function changeAccessControl($idutctrlacesweb, $labels): array
   {
       $accessControllUtilization = InstanceProvider::getService()->getPerfilacesso()->findAccessControlUtilization();
       $accessControlValue = $idutctrlacesweb == 'N' ? 'S' : 'N';

       if(!empty($accessControllUtilization)) {
            $acessProfileOld = $this->paramgeralRepository->findAccessProfileOld(getNrorg());
            if ($acessProfileOld[0]['IDUTLPERFILFILIAL'] !== $accessControlValue)   {
                $arrayValores = [$labels['label'], $accessControlValue];
                $arrayNomes = ['Tela', 'IDUTLPERFILFILIAL'];
                $descricao = AclUtilities::gerarDescricao($arrayValores, $arrayNomes);
                InstanceProvider::getLibLog()->logRegister($acessProfileOld[0]['CDPARGERAL'], $descricao, '2', 'PARAMGERAL', '/access-control');
            }
           $this->paramgeralRepository->updateParamgeralByAccessControl($accessControlValue, getNrorg());
       } else {
           $interval = 1;
           $colSize = 4;
           $cdparamgeral = InstanceProvider::getNewCode()->getCodeByTableName('PARAMGERAL', getNrorg(), $interval, $colSize);
           $this->paramgeralRepository->createParamgeralByAccessControl($accessControlValue, $cdparamgeral, getNrorg());
           $valores = [$labels['label'], $cdparamgeral, $accessControlValue];
           $nomes = ["Tela", 'CDPARAMGERAL', $labels['IDUTCTRLACESWEB']];
           $descricao =  AclUtilities::gerarDescricao($valores, $nomes);
           InstanceProvider::getLibLog()->logRegister($cdparamgeral, $descricao, '1', 'PARAMGERAL', '/access-control');
       }

       return array('idutctrlacesweb' => $accessControlValue);
   }
}
